import _slicedToArray from "@babel/runtime/helpers/esm/slicedToArray";
import _asyncToGenerator from "@babel/runtime/helpers/esm/asyncToGenerator";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _regeneratorRuntime from "@babel/runtime/regenerator";

var BaseLayerPickService = /*#__PURE__*/function () {
  function BaseLayerPickService(layer) {
    _classCallCheck(this, BaseLayerPickService);

    this.layer = layer;
  }

  _createClass(BaseLayerPickService, [{
    key: "pickRender",
    value: function pickRender(target) {
      var layer = this.layer; // 拾取绘制

      if (layer.tileLayer) {
        return layer.tileLayer.pickRender(target);
      }

      layer.hooks.beforePickingEncode.call();

      if (layer.masks.length > 0) {
        // 若存在 mask，则在 pick 阶段的绘制也启用
        layer.masks.map( /*#__PURE__*/function () {
          var _ref = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee(m) {
            return _regeneratorRuntime.wrap(function _callee$(_context) {
              while (1) {
                switch (_context.prev = _context.next) {
                  case 0:
                    m.render();

                  case 1:
                  case "end":
                    return _context.stop();
                }
              }
            }, _callee);
          }));

          return function (_x) {
            return _ref.apply(this, arguments);
          };
        }());
      }

      layer.renderModels(true);
      layer.hooks.afterPickingEncode.call();
    }
  }, {
    key: "selectFeature",
    value: function selectFeature(pickedColors) {
      var layer = this.layer; // @ts-ignore

      var _pickedColors = _slicedToArray(pickedColors, 3),
          r = _pickedColors[0],
          g = _pickedColors[1],
          b = _pickedColors[2];

      layer.hooks.beforeSelect.call([r, g, b]);
    }
  }, {
    key: "highlightPickedFeature",
    value: function highlightPickedFeature(pickedColors) {
      // @ts-ignore
      var _pickedColors2 = _slicedToArray(pickedColors, 3),
          r = _pickedColors2[0],
          g = _pickedColors2[1],
          b = _pickedColors2[2];

      this.layer.hooks.beforeHighlight.call([r, g, b]);
    }
  }, {
    key: "getFeatureById",
    value: function getFeatureById(pickedFeatureIdx) {
      return this.layer.getSource().getFeatureById(pickedFeatureIdx);
    }
  }]);

  return BaseLayerPickService;
}();

export { BaseLayerPickService as default };