import { ILayerService, ITilePickService, IInteractionTarget } from '@antv/l7-core';
import { TileLayerService } from './TileLayerService';
export interface ITilePickServiceOptions {
    layerService: ILayerService;
    tileLayerService: TileLayerService;
}
export declare class TilePickService implements ITilePickService {
    private layerService;
    private tileLayerService;
    private tileSourceService;
    private tilePickID;
    constructor({ layerService, tileLayerService }: ITilePickServiceOptions);
    pickRender(target: IInteractionTarget): void;
    selectFeature(pickedColors: Uint8Array | undefined): void;
    highlightPickedFeature(pickedColors: Uint8Array | undefined): void;
    updateHighLight(r: number, g: number, b: number, type: string): void;
    setPickState(): void;
    private clor2PickId;
    private pickId2Color;
    /** 从瓦片中根据数据 */
    getFeatureById(pickedFeatureIdx: number): any;
}
