"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread2"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _l7Core = require("@antv/l7-core");

var _l7Utils = require("@antv/l7-utils");

var _RasterDataLayer = _interopRequireDefault(require("./layers/RasterDataLayer"));

var _Tile2 = _interopRequireDefault(require("./Tile"));

var _lodash = require("lodash");

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var COLOR_TEXTURE = 'raster-colorTexture';
var COLOR_TEXTURE_OPTION = 'raster-colorTexture-option';
var DEFAULT_COLOR_TEXTURE_OPTION = {
  positions: [0, 1],
  colors: ['#000', '#fff']
};

var RasterTile = /*#__PURE__*/function (_Tile) {
  (0, _inherits2.default)(RasterTile, _Tile);

  var _super = _createSuper(RasterTile);

  function RasterTile() {
    (0, _classCallCheck2.default)(this, RasterTile);
    return _super.apply(this, arguments);
  }

  (0, _createClass2.default)(RasterTile, [{
    key: "initTileLayer",
    value: function () {
      var _initTileLayer = (0, _asyncToGenerator2.default)( /*#__PURE__*/_regenerator.default.mark(function _callee() {
        var attributes, layerOptions, sourceOptions, layer;
        return _regenerator.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                attributes = this.parent.getLayerAttributeConfig();
                layerOptions = this.parent.getLayerConfig();
                sourceOptions = this.getSourceOption();
                this.initColorTexture();
                layer = new _RasterDataLayer.default((0, _objectSpread2.default)((0, _objectSpread2.default)({}, layerOptions), {}, {
                  colorTexture: this.colorTexture
                })).source(sourceOptions.data, sourceOptions.options); // 初始化数据映射

                attributes && Object.keys(attributes).forEach(function (type) {
                  var _attributes$attr, _attributes$attr2;

                  var attr = type; // @ts-ignore

                  layer[attr]((_attributes$attr = attributes[attr]) === null || _attributes$attr === void 0 ? void 0 : _attributes$attr.field, (_attributes$attr2 = attributes[attr]) === null || _attributes$attr2 === void 0 ? void 0 : _attributes$attr2.values);
                });
                _context.next = 8;
                return this.addLayer(layer);

              case 8:
                this.isLoaded = true;

              case 9:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function initTileLayer() {
        return _initTileLayer.apply(this, arguments);
      }

      return initTileLayer;
    }()
  }, {
    key: "getSourceOption",
    value: function getSourceOption() {
      var rawSource = this.parent.getSource();
      return {
        data: this.sourceTile.data.data,
        options: {
          parser: {
            type: 'raster',
            extent: this.sourceTile.bounds,
            width: this.sourceTile.data.width,
            height: this.sourceTile.data.height
          },
          transforms: rawSource.transforms
        }
      };
    }
  }, {
    key: "getTileResource",
    value: function getTileResource() {
      return this.parent.tileLayer.tileLayerService.tileResource;
    }
  }, {
    key: "initColorTexture",
    value: function initColorTexture() {
      var tileResource = this.getTileResource();
      var colorTexture = tileResource.get(COLOR_TEXTURE);

      if (colorTexture) {
        this.colorTexture = colorTexture;
      } else {
        var container = this.parent.getContainer();
        var rendererService = container.get(_l7Core.TYPES.IRendererService);

        var _ref = this.parent.getLayerConfig(),
            _ref$rampColors = _ref.rampColors,
            rampColors = _ref$rampColors === void 0 ? DEFAULT_COLOR_TEXTURE_OPTION : _ref$rampColors;

        this.colorTexture = this.createColorTexture(rampColors, rendererService);
        tileResource.set(COLOR_TEXTURE, this.colorTexture);
        tileResource.set(COLOR_TEXTURE_OPTION, rampColors);
      }
    }
  }, {
    key: "updateColorTexture",
    value: function updateColorTexture() {
      var tileResource = this.getTileResource();
      tileResource.delete(COLOR_TEXTURE);
      this.initColorTexture();
    }
    /**
     * 用于 style 更新 colorTexture 的优化
     * @param arg 
     */

  }, {
    key: "styleUpdate",
    value: function styleUpdate() {
      var _this = this;

      var tileResource = this.getTileResource();

      for (var _len = arguments.length, arg = new Array(_len), _key = 0; _key < _len; _key++) {
        arg[_key] = arguments[_key];
      }

      var _arg$rampColors = arg.rampColors,
          rampColors = _arg$rampColors === void 0 ? DEFAULT_COLOR_TEXTURE_OPTION : _arg$rampColors;
      var cacheRampColors = tileResource.get(COLOR_TEXTURE_OPTION);

      if (!(0, _lodash.isEqual)(rampColors, cacheRampColors)) {
        this.updateColorTexture();
      }

      this.layers.forEach(function (layer) {
        return layer.style({
          colorTexture: _this.colorTexture
        });
      });
    }
  }, {
    key: "createColorTexture",
    value: function createColorTexture(config, rendererService) {
      var createTexture2D = rendererService.createTexture2D;
      var imageData = (0, _l7Utils.generateColorRamp)(config);
      var texture = createTexture2D({
        data: imageData.data,
        width: imageData.width,
        height: imageData.height,
        flipY: false
      });
      return texture;
    }
  }, {
    key: "destroy",
    value: function destroy() {
      this.layers.forEach(function (layer) {
        return layer.destroy();
      });
    }
  }]);
  return RasterTile;
}(_Tile2.default);

exports.default = RasterTile;