"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getMaskLayer = getMaskLayer;
exports.getTileLayer = getTileLayer;

var _index = _interopRequireDefault(require("../../point/index"));

var _line = _interopRequireDefault(require("../../line"));

var _polygon = _interopRequireDefault(require("../../polygon"));

var _mask = _interopRequireDefault(require("../../mask"));

function getTileLayer(type) {
  if (type === 'PolygonLayer') {
    return _polygon.default;
  }

  if (type === 'LineLayer') {
    return _line.default;
  }

  if (type === 'PointLayer') {
    return _index.default;
  }

  return _index.default;
}

function getMaskLayer(type) {
  switch (type) {
    case 'PolygonLayer':
    case 'LineLayer':
      return _mask.default;

    case 'PointLayer':
    case 'RasterLayer':
      return undefined;

    default:
      return undefined;
  }
}